Source-Changes-HG archive

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]

[src/trunk]: src/tests/util/sh Add a test for PR/45613 (eval failing in a tes...



details:   https://anonhg.NetBSD.org/src/rev/cb05ac42675a
branches:  trunk
changeset: 771220:cb05ac42675a
user:      christos <christos%NetBSD.org@localhost>
date:      Mon Nov 14 20:23:29 2011 +0000

description:
Add a test for PR/45613 (eval failing in a tested context)

diffstat:

 tests/util/sh/Makefile        |   3 +-
 tests/util/sh/t_evaltested.sh |  67 +++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 69 insertions(+), 1 deletions(-)

diffs (88 lines):

diff -r cc95c144f84f -r cb05ac42675a tests/util/sh/Makefile
--- a/tests/util/sh/Makefile    Mon Nov 14 18:42:57 2011 +0000
+++ b/tests/util/sh/Makefile    Mon Nov 14 20:23:29 2011 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: Makefile,v 1.3 2009/10/20 21:58:35 jmmv Exp $
+# $NetBSD: Makefile,v 1.4 2011/11/14 20:23:29 christos Exp $
 
 .include <bsd.own.mk>
 
@@ -7,6 +7,7 @@
 TESTS_SH=      t_compexit
 TESTS_SH+=     t_exit
 TESTS_SH+=     t_expand
+TESTS_SH+=     t_evaltested
 TESTS_SH+=     t_fsplit
 TESTS_SH+=     t_here
 TESTS_SH+=     t_set_e
diff -r cc95c144f84f -r cb05ac42675a tests/util/sh/t_evaltested.sh
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/util/sh/t_evaltested.sh     Mon Nov 14 20:23:29 2011 +0000
@@ -0,0 +1,67 @@
+# $NetBSD: t_evaltested.sh,v 1.1 2011/11/14 20:23:29 christos Exp $
+#
+# Copyright (c) 2011 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+# 3. All advertising materials mentioning features or use of this software
+#    must display the following acknowledgement:
+#        This product includes software developed by the NetBSD
+#        Foundation, Inc. and its contributors.
+# 4. Neither the name of The NetBSD Foundation nor the names of its
+#    contributors may be used to endorse or promote products derived
+#    from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+#
+
+atf_test_case evaltested
+
+evaltested_head() {
+       atf_set "descr" "Tests that eval in a tested context does not exit"
+}
+
+evaltested_body() {
+       set -e
+cat > helper.sh << EOF
+set -e
+if eval false
+then
+       echo "'eval false' returned true"
+       exit 1
+fi
+echo "passed"
+exit 0
+EOF
+       output="$(/bin/sh helper.sh)"
+       [ $? = 0 ] && return
+
+       if [ -n "$output" ]
+       then
+               atf_fail "$output"
+       else
+               atf_fail "'eval false' exited from a tested context"
+       fi
+
+}
+
+atf_init_test_cases() {
+       atf_add_test_case evaltested
+}



Home | Main Index | Thread Index | Old Index